2 # Copyright (c) 2007, Nanako Shiraishi
4 USAGE='[ | list | show | apply | clear]'
11 TMP="$GIT_DIR/.git-stash.$$"
12 trap 'rm -f "$TMP-*"' 0
17 git diff-index --quiet --cached HEAD &&
18 git diff-files --quiet
22 if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
24 git update-ref -d refs/stash $current
33 echo >&2 'No local changes to save'
36 test -f "$GIT_DIR/logs/$ref_stash" ||
37 clear_stash || die "Cannot initialize stash"
39 # Make sure the reflog for stash is kept.
40 : >>"$GIT_DIR/logs/$ref_stash"
42 # state of the base commit
43 if b_commit=$(git rev-parse --verify HEAD)
45 head=$(git log --abbrev-commit --pretty=oneline -n 1 HEAD)
47 die "You do not have the initial commit yet"
50 if branch=$(git symbolic-ref -q HEAD)
52 branch=${branch#refs/heads/}
56 msg=$(printf '%s: %s' "$branch" "$head")
59 i_tree=$(git write-tree) &&
60 i_commit=$(printf 'index on %s\n' "$msg" |
61 git commit-tree $i_tree -p $b_commit) ||
62 die "Cannot save the current index state"
64 # state of the working tree
67 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
68 GIT_INDEX_FILE="$TMP-index" &&
69 export GIT_INDEX_FILE &&
70 git read-tree -m $i_tree &&
75 die "Cannot save the current worktree state"
78 if test -z "$stash_msg"
80 stash_msg=$(printf 'WIP on %s' "$msg")
82 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
84 w_commit=$(printf '%s\n' "$stash_msg" |
85 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
86 die "Cannot record working tree state"
88 git update-ref -m "$stash_msg" $ref_stash $w_commit ||
89 die "Cannot save the current status"
90 printf >&2 'Saved "%s"\n' "$stash_msg"
94 git rev-parse --verify $ref_stash >/dev/null 2>&1
98 have_stash || return 0
99 git log --pretty=oneline -g "$@" $ref_stash |
100 sed -n -e 's/^[.0-9a-f]* refs\///p'
104 flags=$(git rev-parse --no-revs --flags "$@")
109 s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
111 w_commit=$(git rev-parse --verify "$s") &&
112 b_commit=$(git rev-parse --verify "$s^") &&
113 git diff $flags $b_commit $w_commit
117 git diff-files --quiet ||
118 die 'Cannot restore on top of a dirty state'
127 # current index state
128 c_tree=$(git write-tree) ||
129 die 'Cannot apply a stash in the middle of a merge'
131 # stash records the work tree, and is a merge between the
132 # base commit (first parent) and the index tree (second parent).
133 s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
134 w_tree=$(git rev-parse --verify "$s:") &&
135 b_tree=$(git rev-parse --verify "$s^1:") &&
136 i_tree=$(git rev-parse --verify "$s^2:") ||
137 die "$*: no valid stashed state found"
139 unstashed_index_tree=
140 if test -n "$unstash_index" && test "$b_tree" != "$i_tree"
142 git diff --binary $s^2^..$s^2 | git apply --cached
144 die 'Conflicts in index. Try without --index.'
145 unstashed_index_tree=$(git-write-tree) ||
146 die 'Could not save index tree'
151 GITHEAD_$w_tree='Stashed changes' &&
152 GITHEAD_$c_tree='Updated upstream' &&
153 GITHEAD_$b_tree='Version stash was based on' &&
154 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
157 if git-merge-recursive $b_tree -- $c_tree $w_tree
160 if test -n "$unstashed_index_tree"
162 git read-tree "$unstashed_index_tree"
165 git diff --cached --name-only --diff-filter=A $c_tree >"$a" &&
166 git read-tree --reset $c_tree &&
167 git update-index --add --stdin <"$a" ||
168 die "Cannot unstage modified files"
173 # Merge conflict; keep the exit status from merge-recursive
175 if test -n "$unstash_index"
177 echo >&2 'Index was not unstashed.'
209 if test $# -gt 0 && test "$1" = save
213 save_stash "$*" && git-reset --hard